/* Copyright (c) 1992 The Geometry Center; University of Minnesota
   1300 South Second Street;  Minneapolis, MN  55454, USA;
   
This file is part of geomview/OOGL. geomview/OOGL is free software;
you can redistribute it and/or modify it only under the terms given in
the file COPYING, which you should have received along with this file.
This and other related software may be obtained via anonymous ftp from
geom.umn.edu; email: software@geom.umn.edu. */

/* Authors: Charlie Gunn, Stuart Levy, Tamara Munzner, Mark Phillips */

/*
 * MG context attributes specific to GL
 *
 * MG_GLBORN may only be gotten.  Not set.
 * MG_GLXSINGLEWIN and MG_GLXDOUBLEWIN are only relevant in GLX mode.
 * Single/double-buffer switching is only possible if the caller creates these
 * windows and supplies their window id's, along with MG_GLXDISPLAY.
 */


#define MG_GLWINID	101	/* window id (returned by winopen) */
#define MG_GLBORN	102	/* born flag (has window been created)? */
#define MG_GLZMAX	103	/* max z-buffer value */
#define	MG_GLXDISPLAY	104	/* X11 Display *  (for mixed model) */
#define	MG_GLXSINGLEWIN	105	/* X Window id of single-buffered window */
#define	MG_GLXDOUBLEWIN	106	/* X Window id of double-buffered window */

#define	MG_BGIMAGEFILE	110	/* Image file for window background */

extern mgcontext *mggl_findctx(int glwinid);
